<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form ref="formRef" :model="formData" :rules="formRules" label-width="120px" v-loading="formLoading">
      <el-form-item :label="t('mall.showStores')" prop="shopId">
        <el-select v-model="formData.shopId" :placeholder="t('mall.selectStore')">
          <el-option v-for="item in shopList" :key="item.id" :label="item.name" :value="item.id" />
        </el-select>
      </el-form-item>
      <el-form-item :label="t('mall.availableType')" prop="type">
        <el-radio-group v-model="formData.type">
          <el-radio :value="0">{{ t('mall.generalPurpose') }}</el-radio>
          <el-radio :value="1">{{ t('mall.used') }}</el-radio>
          <el-radio :value="2">{{ t('mall.unused') }}</el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item :label="t('mall.redeemCode')" prop="exchangeCode">
        <el-input v-model="formData.exchangeCode" :placeholder="t('mall.pleaseEnterTheRedemptionCode')" />
      </el-form-item>
      <el-form-item :label="t('mall.picture')" prop="image">
        <Materials v-model="formData.image" num="1" type="image" />
      </el-form-item>
      <el-form-item :label="t('mall.couponName')" prop="title">
        <el-input v-model="formData.title" :placeholder="t('mall.pleaseEnterTheNameOfTheCoupon')" />
      </el-form-item>
      <el-form-item :label="t('mall.howMuchToSpend')" prop="least">
        <el-input v-model="formData.least" :placeholder="t('mall.pleaseEnterTheAmountOfMoneySpent')" />
      </el-form-item>
      <el-form-item :label="t('mall.couponAmount')" prop="value">
        <el-input v-model="formData.value" :placeholder="t('mall.pleaseEnterTheAmountOfTheCoupon')" />
      </el-form-item>
      <el-form-item :label="t('mall.startTime')" prop="startTime">
        <el-date-picker v-model="formData.startTime" type="date" value-format="x" :placeholder="t('mall.selectStartTime')" />
      </el-form-item>
      <el-form-item :label="t('mall.closingTime')" prop="endTime">
        <el-date-picker v-model="formData.endTime" type="date" value-format="x" :placeholder="t('mall.selectTheEndTime')" />
      </el-form-item>
      <el-form-item :label="t('mall.numberOfIssues')" prop="distribute">
        <el-input v-model="formData.distribute" :placeholder="t('mall.pleaseEnterTheNumberOfIssues')" />
      </el-form-item>
      <el-form-item :label="t('mall.pointsRequired')" prop="score">
        <el-input v-model="formData.score" :placeholder="t('mall.pleaseEnterTheNumberOfPointsRequired')" />
      </el-form-item>
      <el-form-item :label="t('mall.limit')" prop="limit">
        <el-input v-model="formData.limit" :placeholder="t('mall.pleaseEnterTheQuantityLimit')" />
      </el-form-item>
      <el-form-item :label="t('mall.instructionsForUse')" prop="instructions">
        <el-input type="textarea" rows="5" v-model="formData.instructions" :placeholder="t('mall.pleaseEnterTheInstructionsForUse')" />
      </el-form-item>
      <el-form-item :label="t('mall.whetherItIsOnTheShelfOrNot')" prop="isSwitch">
        <el-radio-group v-model="formData.isSwitch">
          <el-radio :value="1">{{ t('common.yes') }}</el-radio>
          <el-radio :value="0">{{ t('common.no') }}</el-radio>
        </el-radio-group>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">{{ t('common.confirm') }}</el-button>
      <el-button @click="dialogVisible = false">{{ t('common.cancel') }}</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import * as Api from '@/api/mall/coupon/'
import * as ShopApi from '@/api/mall/store/shop'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  shopId: undefined,
  shopName: undefined,
  title: undefined,
  isSwitch: undefined,
  least: undefined,
  value: undefined,
  startTime: undefined,
  endTime: undefined,
  weigh: undefined,
  type: undefined,
  exchangeCode: undefined,
  receive: undefined,
  distribute: undefined,
  score: undefined,
  instructions: undefined,
  image: undefined,
  limit: undefined
})
const shopList = ref([])
const formRules = reactive({
  shopId: [{ required: true, message: t('mall.storeId0MeansGenericCantBeEmpty'), trigger: 'blur' }],
  title: [{ required: true, message: t('mall.couponNameCannotBeEmpty'), trigger: 'blur' }],
  least: [{ required: true, message: t('mall.consumptionOfHowMuchIsAvailableCanNotBeEmpty'), trigger: 'blur' }],
  value: [{ required: true, message: t('mall.couponAmountCannotBeEmpty'), trigger: 'blur' }],
  startTime: [{ required: true, message: t('mall.startTimeCannotBeEmpty'), trigger: 'blur' }],
  endTime: [{ required: true, message: t('mall.endTimeCannotBeEmpty'), trigger: 'blur' }],
  type: [{ required: true, message: t('mall.availableTypeCannotBeEmpty'), trigger: 'blur' }],
  distribute: [{ required: true, message: t('mall.theNumberOfCouponsIssuedCannotBeEmpty'), trigger: 'blur' }],
  limit: [{ required: true, message: t('mall.limitOnNumberOfCouponsCannotBeEmpty'), trigger: 'blur' }],
  instructions: [{ required: true, message: t('mall.descriptionOfUseCannotBeEmpty'), trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  getList()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await Api.getCoupon(id)
      formData.value.shopId = Number(formData.value.shopId)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as Api.VO
    if (formType.value === 'create') {
      await Api.createCoupon(data)
      message.success(t('common.createSuccess'))
    } else {
      await Api.updateCoupon(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}
const getList = async () => {
  try {
    const data = await ShopApi.getShopList()
    shopList.value = data
  } finally {
  }
}
/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    shopId: undefined,
    shopName: undefined,
    title: undefined,
    isSwitch: 1,
    least: undefined,
    value: undefined,
    startTime: undefined,
    endTime: undefined,
    weigh: undefined,
    type: 0,
    exchangeCode: undefined,
    receive: undefined,
    distribute: undefined,
    score: undefined,
    instructions: undefined,
    image: undefined,
    limit: undefined
  }
  formRef.value?.resetFields()
}
</script>
